Package org.apache.groovy.ginq.dsl

# Class GinqAstBuilder

java.lang.Object
org.codehaus.groovy.ast.CodeVisitorSupport
org.apache.groovy.ginq.dsl.GinqAstBuilder

All Implemented Interfaces:
  `SyntaxErrorReportable`, `GroovyCodeVisitor`

public class GinqAstBuilder extends CodeVisitorSupport implements SyntaxErrorReportable
Build the AST for GINQ

Since:
  4.0.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `GINQ_SELECT_DISTINCT`
  `static final String`
  `ROOT_GINQ_EXPRESSION`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `GinqAstBuilder(SourceUnit sourceUnit)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AbstractGinqExpression`
  `buildAST(ASTNode astNode)`
  `SourceUnit`
  `getSourceUnit()`
  `void`
  `visitArgumentlistExpression(ArgumentListExpression expression)`
  `void`
  `visitBinaryExpression(BinaryExpression expression)`
  `void`
  `visitCastExpression(CastExpression expression)`
  `void`
  `visitDeclarationExpression(DeclarationExpression expression)`
  `void`
  `visitMethodCallExpression(MethodCallExpression call)`
  `void`
  `visitPropertyExpression(PropertyExpression expression)`
  `void`
  `visitVariableExpression(VariableExpression expression)`

  ### Methods inherited from class org.codehaus.groovy.ast.CodeVisitorSupport

  `afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitWhileLoop`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.codehaus.groovy.ast.GroovyCodeVisitor

  `visit, visit, visitEmptyExpression, visitListOfExpressions`

  ### Methods inherited from interface org.apache.groovy.ginq.dsl.SyntaxErrorReportable

  `collectSyntaxError`

- ## Field Details

  - ### ROOT_GINQ_EXPRESSION

    public static final String ROOT_GINQ_EXPRESSION
    See Also:
      - Constant Field Values

  - ### GINQ_SELECT_DISTINCT

    public static final String GINQ_SELECT_DISTINCT
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### GinqAstBuilder

    public GinqAstBuilder(SourceUnit sourceUnit)

- ## Method Details

  - ### buildAST

    public AbstractGinqExpression buildAST(ASTNode astNode)

  - ### visitMethodCallExpression

    public void visitMethodCallExpression(MethodCallExpression call)
    Specified by:
      `visitMethodCallExpression` in interface `GroovyCodeVisitor`
    Overrides:
      `visitMethodCallExpression` in class `CodeVisitorSupport`

  - ### visitBinaryExpression

    public void visitBinaryExpression(BinaryExpression expression)
    Specified by:
      `visitBinaryExpression` in interface `GroovyCodeVisitor`
    Overrides:
      `visitBinaryExpression` in class `CodeVisitorSupport`

  - ### visitVariableExpression

    public void visitVariableExpression(VariableExpression expression)
    Specified by:
      `visitVariableExpression` in interface `GroovyCodeVisitor`
    Overrides:
      `visitVariableExpression` in class `CodeVisitorSupport`

  - ### visitPropertyExpression

    public void visitPropertyExpression(PropertyExpression expression)
    Specified by:
      `visitPropertyExpression` in interface `GroovyCodeVisitor`
    Overrides:
      `visitPropertyExpression` in class `CodeVisitorSupport`

  - ### visitDeclarationExpression

    public void visitDeclarationExpression(DeclarationExpression expression)
    Specified by:
      `visitDeclarationExpression` in interface `GroovyCodeVisitor`
    Overrides:
      `visitDeclarationExpression` in class `CodeVisitorSupport`

  - ### visitCastExpression

    public void visitCastExpression(CastExpression expression)
    Specified by:
      `visitCastExpression` in interface `GroovyCodeVisitor`
    Overrides:
      `visitCastExpression` in class `CodeVisitorSupport`

  - ### visitArgumentlistExpression

    public void visitArgumentlistExpression(ArgumentListExpression expression)
    Specified by:
      `visitArgumentlistExpression` in interface `GroovyCodeVisitor`
    Overrides:
      `visitArgumentlistExpression` in class `CodeVisitorSupport`

  - ### getSourceUnit

    public SourceUnit getSourceUnit()
    Specified by:
      `getSourceUnit` in interface `SyntaxErrorReportable`